package internal

import (
	"codeup.aliyun.com/6552e56cc3b2728a4557fc18/plugin/proto"
	"encoding/json"
	"net/http"
	"plugins/zltx/internal/po"
	"time"
)

func rechargeReq(c *proto.OrderRequest) *po.OrderReq {
	return &po.OrderReq{
		MerchantId:      c.Config.AppId,
		OutTradeNo:      c.Order.OrderNo,
		ProductId:       c.Product.ProductNo,
		RechargeAccount: c.Order.Account,
		AccountType:     1,
		Number:          1,
		Version:         "1.0",
		TimeStamp:       time.Now().Unix(),
		NotifyUrl:       c.Config.NotifyUrl,
	}
}

func rechargeResp(resp po.OrderResp) *proto.OrderResponse {
	data, _ := json.Marshal(resp)
	return &proto.OrderResponse{
		Result: &proto.Result{
			Status:  proto.Status_ING,
			OrderNo: "",
			TradeNo: "",
			Message: resp.Message,
			Data:    data,
		},
	}
}

func queryReq(in *proto.QueryRequest) *po.QueryReq {
	return &po.QueryReq{
		MerchantId: in.Config.AppId,
		//OutTradeNo: in.OutTradeNumber,
		TimeStamp: time.Now().Unix(),
		Version:   "1.0",
	}
}

func queryResp(resp po.QueryResp) *proto.QueryResponse {
	_, _ = json.Marshal(resp)
	return &proto.QueryResponse{
		//OutTradeNumber: in.OutTradeNumber,
		//TradeNumber:    "",
		//Status:         resp.Status.GetOrderStatus(),
		//TradePrice:     in.Product.Price,
		//Data:           data,
		//Message:        resp.Message,
	}
}

func notifyResp(poReq po.Notify) *proto.NotifyResponse {
	headers := make(http.Header)
	headers.Add("content-type", "text/plain")
	_, _ = json.Marshal(headers)
	return &proto.NotifyResponse{
		//Result: poReq.Status.IsSuccess(),
		//Msg:    "回调返回",
		//Data: dto.NotifyResponseData{
		//	Headers: h,
		//	Body:    []byte("success"),
		//},
	}
}
